<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2008 osCommerce

  Released under the GNU General Public License

  http://addons.oscommerce.com/info/487
*/

	if(!defined('TABLE_DIM_WEIGHT')) {
		define('TABLE_DIM_WEIGHT','inxpress_variant');
	}
	
	if(!defined('INXPRESS_REG_URL')) {
		define('INXPRESS_REG_URL','http://inxpressaz.force.com/leadcreation');
	}
	
	if(!defined('INXPRESS_CONTROL_REG_URL')) {
		define('INXPRESS_CONTROL_REG_URL','http://www.ixpapi.com/ixpadmin/control/index.php/downloadInfo/create');
	}
	
	function tep_inxpress_handling_type() {
		return '<select name="configuration[MODULE_SHIPPING_INXPRESS_HANDLING_TYPE]"><option value="0" '.(MODULE_SHIPPING_INXPRESS_HANDLING_TYPE==0?'selected="selected"':'').'>Percentage</option><option value="1" '.(MODULE_SHIPPING_INXPRESS_HANDLING_TYPE==1?'selected="selected"':'').'>Fixed</option></select>';
	}
	
	function tep_inxpress_handling_type_title() {
		return MODULE_SHIPPING_INXPRESS_HANDLING_TYPE==0?'Percentage':'Fixed';
	}


	class inxpress {
		var $code, $title, $description, $icon, $enabled, $countries;
	
		// class constructor
		function inxpress() {
			global $order;
			
			$this->code = 'inxpress';
			$this->title = MODULE_SHIPPING_INXPRESS_TEXT_TITLE;
			$this->description = MODULE_SHIPPING_INXPRESS_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_SHIPPING_INXPRESS_SORT_ORDER;
			//$this->icon = DIR_WS_ICONS . 'shipping_usps.gif';
			$this->tax_class = MODULE_SHIPPING_INXPRESS_TAX_CLASS;
			$this->enabled = ((MODULE_SHIPPING_INXPRESS_STATUS == 'True') ? true : false);
			
			if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_INXPRESS_ZONE > 0) ) {
				$check_flag = false;
				$check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_INXPRESS_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
				while ($check = tep_db_fetch_array($check_query)) {
					if ($check['zone_id'] < 1) {
						$check_flag = true;
						break;
					} elseif ($check['zone_id'] == $order->delivery['zone_id']) {
						$check_flag = true;
						break;
					}
				}
				
				if ($check_flag == false) {
					$this->enabled = false;
				}
			}
			$this->countries = $this->country_list();
		}
	
		// class methods
		function quote($method = '') {
			global $order, $shipping_weight, $shipping_num_boxes;
			
			$inxpressQuote = $this->_getQuote();
			
			if ($inxpressQuote && is_array($inxpressQuote)) {
				
				if(MODULE_SHIPPING_INXPRESS_HANDLING>0) {
					if(MODULE_SHIPPING_INXPRESS_HANDLING_TYPE==0) {
						$inxpressQuote['price'] = $inxpressQuote['price']+(($inxpressQuote['price']*MODULE_SHIPPING_INXPRESS_HANDLING/100));
					} elseif(MODULE_SHIPPING_INXPRESS_HANDLING==1) {
						$inxpressQuote['price'] = $inxpressQuote['price']+MODULE_SHIPPING_INXPRESS_HANDLING;
					}
				}
			
			
				$this->quotes = array('id' => $this->code,
								'module' => MODULE_SHIPPING_INXPRESS_TEXT_TITLE,
								'methods' => array(array('id' => $this->code,
								'title' => MODULE_SHIPPING_INXPRESS_TEXT_WAY.' ( Transit Days: '.$inxpressQuote['days'].' )',
								'cost' => $inxpressQuote['price'])));
			
				if ($this->tax_class > 0) {
					$this->quotes['tax'] = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
				}
			} else {
				$this->quotes = array('module' => $this->title,
							'error' => MODULE_SHIPPING_INXPRESS_TEXT_ERROR);
			}
			if (tep_not_null($this->icon)) $this->quotes['icon'] = tep_image($this->icon, $this->title);
			
			return $this->quotes;
		}
	
	
		function _getQuote() {
			global $order, $cart, $currencies;
			$shippingQuote = array();
			$transitDays = 0;
			$shippingPrice = 0;
			$final_lbh = '';
			$weight=0;
			$country_code = isset($order->delivery['country']['iso_code_2'])?$order->delivery['country']['iso_code_2']:'US';
			$post_code = $order->delivery['postcode'];
			for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
				$weightProduct = $order->products[$i]['weight'];
				$qtyProduct = $order->products[$i]['qty'];
				$variant_query = tep_db_query('SELECT * FROM '.TABLE_DIM_WEIGHT.' WHERE product_id="'.tep_db_prepare_input($order->products[$i]['id']).'" LIMIT 1');
				$dimweight1 = tep_db_fetch_array($variant_query);
				if(!empty($dimweight1)) {
					$dimweight[0] = $dimweight1;
					$variable=$dimweight[0]['variable'];	
					if(($variable!=''&&$variable!=0)) {					
						if($variable>=$qtyProduct) {								
							if($dimweight[0]['dim_weight'] > $weightProduct) {
								$final_lbh.=$dimweight[0]['length'].'|'.$dimweight[0]['width'].'|'.$dimweight[0]['height'].'|'.$weightProduct.';';
								$weight=$weight+$dimweight[0]['dim_weight'];
							} else {
								$final_lbh.=$dimweight[0]['length'].'|'.$dimweight[0]['width'].'|'.$dimweight[0]['height'].'|'.$weightProduct.';';
								$weight=$weight+$weightProduct;
							}					
						} else if($variable<$qtyProduct) {
							$qty=ceil(($qtyProduct)/$variable);	
							$prod_weight=$weightProduct*$qty;
							$prod_dim_weight=$dimweight[0]['dim_weight']*$qty;
							if($prod_dim_weight > $prod_weight) {
								$final_lbh.=$dimweight[0]['length'].'|'.$dimweight[0]['width'].'|'.$dimweight[0]['height'].'|'.$prod_weight.';';
								$weight=$weight+$prod_dim_weight;
							} else {
								$final_lbh.=$dimweight[0]['length'].'|'.$dimweight[0]['width'].'|'.$dimweight[0]['height'].'|'.$prod_weight.';';
								$weight=$weight+($weightProduct*$qty);
							}
						}
					} else {
						$prod_weight=$weightProduct*$qtyProduct;
						$prod_dim_weight=$dimweight[0]['dim_weight']*$qtyProduct;
						if($prod_dim_weight > $prod_weight)
						{
							$final_lbh.=$dimweight[0]['length'].'|'.$dimweight[0]['width'].'|'.$dimweight[0]['height'].'|'.$prod_weight.';';
							$weight=$weight+$prod_dim_weight;
						} else {
							$final_lbh.=$dimweight[0]['length'].'|'.$dimweight[0]['width'].'|'.$dimweight[0]['height'].'|'.$prod_weight.';';
							$weight=$weight+($weightProduct*$qtyProduct);
						}
					}
				} else {
					$weight=$weight+($weightProduct*$qtyProduct);
				}				
			}
		
			$code='';
			if($weight>0.5)	{
				$code='P';
			} else if($weight!=0&&$weight<=0.5) {
				$code='X';
			}
			$final_lbh = trim($final_lbh,';');
			$price=$this->calcRate(MODULE_SHIPPING_INXPRESS_USERID,$code,$country_code,$weight,$final_lbh,$post_code);		
			if($price)
			{	
				$shippingPrice=($shippingPrice+$price['price']);
				$transitDays = $price['days'];
			} else {
				return false;
			}
			$shippingQuote['price'] = $shippingPrice;
			$shippingQuote['days'] = $transitDays;
			
			return $shippingQuote;
		}
	
	
		public function calcRate($account,$code,$country,$weight,$dimension,$zip)
		{
			$url = MODULE_SHIPPING_INXPRESS_GATEWAY_URL.'?acc='.$account.'&dst='.$country.'&prd='.$code.'&wgt='.$weight.'&pst='.$zip.'&pcs='.$dimension;
			//mkdir(DIR_FS_CATALOG.'includes/work/inxpress.log','0777');
			//error_log(strftime(STORE_PARSE_DATE_TIME_FORMAT) . $url . "\n", 3, DIR_FS_CATALOG.'includes/work/inxpress.log');
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL,$url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,false);
			$data = curl_exec ($ch);
			curl_close ($ch); 
			$xml = preg_replace("/(<\/?)(\w+):([^>]*>)/", "$1$2$3", $data);
			$xml = simplexml_load_string($xml);
			$json = json_encode($xml);
			$responseArray = json_decode($json,true);
			if(isset($responseArray['totalCharge']))
			{
				$response=array();
				$response['price']=$responseArray['totalCharge'];
				$response['days']=$responseArray['info']['baseCountryTransitDays'];
				return $response;
			} else {
				return false;
			}	
		}
	
		function check() {
			if (!isset($this->_check)) {
				$check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_INXPRESS_STATUS'");
				$this->_check = tep_db_num_rows($check_query);
			}
			return $this->_check;
		}
		
		
	
		function install() {
			if(MODULE_SHIPPING_INXPRESS_INSTALLED && MODULE_SHIPPING_INXPRESS_INSTALLED==1) {
			}
			else {
				tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('INXPRESS Shipping Installed', 'MODULE_SHIPPING_INXPRESS_INSTALLED', '1', 'INXPRESS Shipping Installed', '6', '0', now())");
				tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Gateway URL', 'MODULE_SHIPPING_INXPRESS_GATEWAY_URL', 'http://www.ixpapi.com/ixpapp/rates.php', 'Gateway URL', '6', '0', now())");
				tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('INXPRESS Account Number', 'MODULE_SHIPPING_INXPRESS_USERINACC', 'NONE', 'INXPRESS Account Number', '6', '0', now())");
				tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Account Number', 'MODULE_SHIPPING_INXPRESS_USERID', 'NONE', 'Enter the Account Number assigned to you.', '6', '0', now())");
				$this->register_with_ixpapi();
				$this->installVariant();
			}
			tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable INXPRESS Shipping', 'MODULE_SHIPPING_INXPRESS_STATUS', 'False', 'Do you want to offer INXPRESS shipping?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
			tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Handling Type', 'MODULE_SHIPPING_INXPRESS_HANDLING_TYPE', '0', 'Handling type for this shipping method.', '6', '0', 'tep_inxpress_handling_type_title', 'tep_inxpress_handling_type(', now())");
			tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee', 'MODULE_SHIPPING_INXPRESS_HANDLING', '0', 'Handling fee for this shipping method.', '6', '1', now())");
			tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_SHIPPING_INXPRESS_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', '6', '0', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
			tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Shipping Zone', 'MODULE_SHIPPING_INXPRESS_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', '6', '0', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
			tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_SHIPPING_INXPRESS_SORT_ORDER', '0', 'Sort order of display.', '6', '0', now())");
		}
	
		function register_with_ixpapi()
		{
			try {
				$company=STORE_NAME;
				$firstname=STORE_OWNER;
				$lastname=STORE_OWNER;
				$countryID = STORE_COUNTRY;
				$countryName = '';
				if(isset($countryID) && $countryID!='') {
					$country_query = tep_db_query("select countries_name as name from " . TABLE_COUNTRIES . " where countries_id = '" . $countryID . "' limit 1");
					$country = tep_db_fetch_array($country_query);
					if($country && isset($country['name'])) {
						$countryName = $country['name'];
					}
				}
			
				$region_name = '';
				$regionId = STORE_ZONE;
				if(isset($regionId) && $regionId!='') {
					$region_query = tep_db_query("select zone_name as name from " . TABLE_ZONES . " where zone_id = '" . $regionId . "' limit 1");
					$region = tep_db_fetch_array($region_query);
					if($region && isset($region['name'])) {
						$region_name = $region['name'];
					}
				}
			
				$city='';
				$zip='';
				$phone='';
				$email = STORE_OWNER_EMAIL_ADDRESS;
				$address = STORE_NAME_ADDRESS;
				$website=tep_catalog_href_link();
				if($company=='')
				{
					$company='Oscommerce Store';
				}
			
				$url = INXPRESS_REG_URL.'?cmp='.$company.'&fn='.$firstname.'&ln='.$lastname.'&add='.$address.'&ct='.$city.'&st='.$region_name.'&cnt='.$countryName.'&zp='.$zip.'&ph='.$phone.'&em='.$email.'&ws='.$website.'&ls=oscommerce';
			
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL,$url);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,false);
				$data = curl_exec ($ch);
				$key1=md5(substr ($website,8,6)."_".time().substr ($email,2,5));
				$post_string = '';
				$params = array(
					'firstname'=>$firstname,
					'lastname'=>$lastname,
					'company'=>$company,
					'phone'=>$phone,
					'email'=>$email,
					'address'=>$address,
					'city'=>$city,
					'state'=>$region_name,
					'country'=>$countryName,
					'zipcode'=>$zip,
					'website'=>$website,
					'framework'=>4,
					'key'=>$key1,
				);
			
				tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_SHIPPING_INXPRESS_KEY', '".$key1."', 'Inxpress Module Key.', '6', '0', now())");
			
				foreach($params as $key=>$value) { $post_string .= $key.'='.$value.'&'; }
				$post_string = rtrim($post_string, '&');
			
				$url=INXPRESS_CONTROL_REG_URL;
			
				$ch = curl_init($url);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $post_string);
				$result = curl_exec($ch);
				curl_close($ch);
			} catch (Exception $e) {
				echo $e->getMessage(); die;
			}
		}
	
		function installVariant() {
			if ( tep_db_num_rows(tep_db_query("show tables like 'inxpress_variant'")) != 1 ) {
				$sql = 'CREATE TABLE IF NOT EXISTS `inxpress_variant` (
				`id` int(11) NOT NULL auto_increment,
				`product_id` int(11),
				`website` int(11),
				`store` int(11),
				`variant` text,
				`modifieddate` datetime,
				`length` text,
				`width` text,
				`height` text,
				`dim_weight` text,
				`variable` text,
				`extra` text,
				PRIMARY KEY  (`id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;';
				
				tep_db_query($sql);
			}
			if ( tep_db_num_rows(tep_db_query("show tables like 'inxpress_dhl'")) != 1 ) {
				$sql = 'CREATE TABLE IF NOT EXISTS `inxpress_dhl` (
				`id` int(11) NOT NULL auto_increment,
				`website` int(11),
				`store` int(11),
				`supplies` text,
				`modifieddate` datetime,
				`length` text,
				`width` text,
				`height` text,
				`dim_weight` text,
				`variable` text,
				`extra` text,
				PRIMARY KEY  (`id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;';		
				tep_db_query($sql);
				
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Express Envelope','12.6','9.4','1',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Express Legal Envelope','15','9.4','1',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Small Padded Pouch','9.8','12','1',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Large Padded Pouch','11.9','14.8','1',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Standard Flyer (Small Express Pack)','11.8','15.7','1',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Large Flyer (Large Express Pack)','15','18.7','1',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Box #2 Cube','10.8','5.8','5.9',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Box #2 Small','12.5','11.1','1.5',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Box #2 Medium','13.2','12.6','2.0',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Box #3 Large','17.5','12.5','3.0',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Box #3 Small Tri-Tube','5','5','25',now());");
				tep_db_query("INSERT INTO inxpress_dhl (supplies,length,width,height,modifieddate) values ('Box #4 Large Tri-Tube','38.4','6.9','6.9',now());");
				
			}
			
		}
	
		function remove() {
			tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->remkeys()) . "')");
		}
		
		function keys() {
			return array('MODULE_SHIPPING_INXPRESS_STATUS', 'MODULE_SHIPPING_INXPRESS_USERINACC', 'MODULE_SHIPPING_INXPRESS_USERID', 'MODULE_SHIPPING_INXPRESS_TAX_CLASS', 'MODULE_SHIPPING_INXPRESS_ZONE', 'MODULE_SHIPPING_INXPRESS_SORT_ORDER', 'MODULE_SHIPPING_INXPRESS_HANDLING_TYPE', 'MODULE_SHIPPING_INXPRESS_HANDLING');
		}
	
		function remkeys() {
			
			return array('MODULE_SHIPPING_INXPRESS_STATUS', 'MODULE_SHIPPING_INXPRESS_HANDLING', 'MODULE_SHIPPING_INXPRESS_TAX_CLASS', 'MODULE_SHIPPING_INXPRESS_ZONE', 'MODULE_SHIPPING_INXPRESS_SORT_ORDER');
		}
	
		function _setService($service) {
			$this->service = $service;
		}
		
		function _setWeight($pounds, $ounces=0) {
			$this->pounds = $pounds;
			$this->ounces = $ounces;
		}
	
		function _setContainer($container) {
			$this->container = $container;
		}
	
		function _setSize($size) {
			$this->size = $size;
		}
	
		function _setMachinable($machinable) {
			$this->machinable = $machinable;
		}
	
	
	
		function country_list() {
			$list = array('AF' => 'Afghanistan',
					'AL' => 'Albania',
					'DZ' => 'Algeria',
					'AD' => 'Andorra',
					'AO' => 'Angola',
					'AI' => 'Anguilla',
					'AG' => 'Antigua and Barbuda',
					'AR' => 'Argentina',
					'AM' => 'Armenia',
					'AW' => 'Aruba',
					'AU' => 'Australia',
					'AT' => 'Austria',
					'AZ' => 'Azerbaijan',
					'BS' => 'Bahamas',
					'BH' => 'Bahrain',
					'BD' => 'Bangladesh',
					'BB' => 'Barbados',
					'BY' => 'Belarus',
					'BE' => 'Belgium',
					'BZ' => 'Belize',
					'BJ' => 'Benin',
					'BM' => 'Bermuda',
					'BT' => 'Bhutan',
					'BO' => 'Bolivia',
					'BA' => 'Bosnia-Herzegovina',
					'BW' => 'Botswana',
					'BR' => 'Brazil',
					'VG' => 'British Virgin Islands',
					'BN' => 'Brunei Darussalam',
					'BG' => 'Bulgaria',
					'BF' => 'Burkina Faso',
					'MM' => 'Burma',
					'BI' => 'Burundi',
					'KH' => 'Cambodia',
					'CM' => 'Cameroon',
					'CA' => 'Canada',
					'CV' => 'Cape Verde',
					'KY' => 'Cayman Islands',
					'CF' => 'Central African Republic',
					'TD' => 'Chad',
					'CL' => 'Chile',
					'CN' => 'China',
					'CX' => 'Christmas Island (Australia)',
					'CC' => 'Cocos Island (Australia)',
					'CO' => 'Colombia',
					'KM' => 'Comoros',
					'CG' => 'Congo (Brazzaville),Republic of the',
					'ZR' => 'Congo, Democratic Republic of the',
					'CK' => 'Cook Islands (New Zealand)',
					'CR' => 'Costa Rica',
					'CI' => 'Cote d\'Ivoire (Ivory Coast)',
					'HR' => 'Croatia',
					'CU' => 'Cuba',
					'CY' => 'Cyprus',
					'CZ' => 'Czech Republic',
					'DK' => 'Denmark',
					'DJ' => 'Djibouti',
					'DM' => 'Dominica',
					'DO' => 'Dominican Republic',
					'TP' => 'East Timor (Indonesia)',
					'EC' => 'Ecuador',
					'EG' => 'Egypt',
					'SV' => 'El Salvador',
					'GQ' => 'Equatorial Guinea',
					'ER' => 'Eritrea',
					'EE' => 'Estonia',
					'ET' => 'Ethiopia',
					'FK' => 'Falkland Islands',
					'FO' => 'Faroe Islands',
					'FJ' => 'Fiji',
					'FI' => 'Finland',
					'FR' => 'France',
					'GF' => 'French Guiana',
					'PF' => 'French Polynesia',
					'GA' => 'Gabon',
					'GM' => 'Gambia',
					'GE' => 'Georgia, Republic of',
					'DE' => 'Germany',
					'GH' => 'Ghana',
					'GI' => 'Gibraltar',
					'GB' => 'Great Britain and Northern Ireland',
					'GR' => 'Greece',
					'GL' => 'Greenland',
					'GD' => 'Grenada',
					'GP' => 'Guadeloupe',
					'GT' => 'Guatemala',
					'GN' => 'Guinea',
					'GW' => 'Guinea-Bissau',
					'GY' => 'Guyana',
					'HT' => 'Haiti',
					'HN' => 'Honduras',
					'HK' => 'Hong Kong',
					'HU' => 'Hungary',
					'IS' => 'Iceland',
					'IN' => 'India',
					'ID' => 'Indonesia',
					'IR' => 'Iran',
					'IQ' => 'Iraq',
					'IE' => 'Ireland',
					'IL' => 'Israel',
					'IT' => 'Italy',
					'JM' => 'Jamaica',
					'JP' => 'Japan',
					'JO' => 'Jordan',
					'KZ' => 'Kazakhstan',
					'KE' => 'Kenya',
					'KI' => 'Kiribati',
					'KW' => 'Kuwait',
					'KG' => 'Kyrgyzstan',
					'LA' => 'Laos',
					'LV' => 'Latvia',
					'LB' => 'Lebanon',
					'LS' => 'Lesotho',
					'LR' => 'Liberia',
					'LY' => 'Libya',
					'LI' => 'Liechtenstein',
					'LT' => 'Lithuania',
					'LU' => 'Luxembourg',
					'MO' => 'Macao',
					'MK' => 'Macedonia, Republic of',
					'MG' => 'Madagascar',
					'MW' => 'Malawi',
					'MY' => 'Malaysia',
					'MV' => 'Maldives',
					'ML' => 'Mali',
					'MT' => 'Malta',
					'MQ' => 'Martinique',
					'MR' => 'Mauritania',
					'MU' => 'Mauritius',
					'YT' => 'Mayotte (France)',
					'MX' => 'Mexico',
					'MD' => 'Moldova',
					'MC' => 'Monaco (France)',
					'MN' => 'Mongolia',
					'MS' => 'Montserrat',
					'MA' => 'Morocco',
					'MZ' => 'Mozambique',
					'NA' => 'Namibia',
					'NR' => 'Nauru',
					'NP' => 'Nepal',
					'NL' => 'Netherlands',
					'AN' => 'Netherlands Antilles',
					'NC' => 'New Caledonia',
					'NZ' => 'New Zealand',
					'NI' => 'Nicaragua',
					'NE' => 'Niger',
					'NG' => 'Nigeria',
					'KP' => 'North Korea (Korea, Democratic People\'s Republic of)',
					'NO' => 'Norway',
					'OM' => 'Oman',
					'PK' => 'Pakistan',
					'PA' => 'Panama',
					'PG' => 'Papua New Guinea',
					'PY' => 'Paraguay',
					'PE' => 'Peru',
					'PH' => 'Philippines',
					'PN' => 'Pitcairn Island',
					'PL' => 'Poland',
					'PT' => 'Portugal',
					'QA' => 'Qatar',
					'RE' => 'Reunion',
					'RO' => 'Romania',
					'RU' => 'Russia',
					'RW' => 'Rwanda',
					'SH' => 'Saint Helena',
					'KN' => 'Saint Kitts (St. Christopher and Nevis)',
					'LC' => 'Saint Lucia',
					'PM' => 'Saint Pierre and Miquelon',
					'VC' => 'Saint Vincent and the Grenadines',
					'SM' => 'San Marino',
					'ST' => 'Sao Tome and Principe',
					'SA' => 'Saudi Arabia',
					'SN' => 'Senegal',
					'YU' => 'Serbia-Montenegro',
					'SC' => 'Seychelles',
					'SL' => 'Sierra Leone',
					'SG' => 'Singapore',
					'SK' => 'Slovak Republic',
					'SI' => 'Slovenia',
					'SB' => 'Solomon Islands',
					'SO' => 'Somalia',
					'ZA' => 'South Africa',
					'GS' => 'South Georgia (Falkland Islands)',
					'KR' => 'South Korea (Korea, Republic of)',
					'ES' => 'Spain',
					'LK' => 'Sri Lanka',
					'SD' => 'Sudan',
					'SR' => 'Suriname',
					'SZ' => 'Swaziland',
					'SE' => 'Sweden',
					'CH' => 'Switzerland',
					'SY' => 'Syrian Arab Republic',
					'TW' => 'Taiwan',
					'TJ' => 'Tajikistan',
					'TZ' => 'Tanzania',
					'TH' => 'Thailand',
					'TG' => 'Togo',
					'TK' => 'Tokelau (Union) Group (Western Samoa)',
					'TO' => 'Tonga',
					'TT' => 'Trinidad and Tobago',
					'TN' => 'Tunisia',
					'TR' => 'Turkey',
					'TM' => 'Turkmenistan',
					'TC' => 'Turks and Caicos Islands',
					'TV' => 'Tuvalu',
					'UG' => 'Uganda',
					'UA' => 'Ukraine',
					'AE' => 'United Arab Emirates',
					'UY' => 'Uruguay',
					'UZ' => 'Uzbekistan',
					'VU' => 'Vanuatu',
					'VA' => 'Vatican City',
					'VE' => 'Venezuela',
					'VN' => 'Vietnam',
					'WF' => 'Wallis and Futuna Islands',
					'WS' => 'Western Samoa',
					'YE' => 'Yemen',
					'ZM' => 'Zambia',
					'ZW' => 'Zimbabwe'
				);
			return $list;
		}
	}
	?>
